#!/usr/bin/python2
# -*- coding: utf-8 -*-

#	Copyright 2012, Marten de Vries
#
#	This file is part of OpenTeacher.
#
#	OpenTeacher is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	OpenTeacher is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with OpenTeacher.  If not, see <http://www.gnu.org/licenses/>.

class WordsReverserModule(object):
	def __init__(self, moduleManager, *args, **kwargs):
		super(WordsReverserModule, self).__init__(*args, **kwargs)
		self._mm = moduleManager

		self.type = "reverser"
		self.dataType = "words"

	def reverse(self, list):
		"""Reverses the list word list. Crashes if the dataType isn't
		   words. Modifies the list in place (returns nothing).

		"""
		#reverse question & answers
		for word in list["items"]:
			word["questions"], word["answers"] = word.get("answers", []), word.get("questions", [])

		#reverse questionLanguage & answerLanguage
		list["questionLanguage"], list["answerLanguage"] = list.get("answerLanguage", u""), list.get("questionLanguage", u"")

	def enable(self):
		self.active = True

	def disable(self):
		self.active = False

def init(moduleManager):
	return WordsReverserModule(moduleManager)
